//+------------------------------------------------------------------+
//|                                             MarketUpdateTest.mq5 |
//|                        Copyright 2016, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"

input ulong ExtCollectTime   =30;  //    
input ulong ExtSkipFirstTicks=10;  //     

//---      
MqlBookInfo  book[];
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---  
   Comment(StringFormat("Waiting for first %I64u ticks",ExtSkipFirstTicks));
   PrintFormat("Waiting for first %I64u ticks",ExtSkipFirstTicks);
//---   
   MarketBookAdd(_Symbol);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
  }
//+------------------------------------------------------------------+
//| BookEvent function                                               |
//+------------------------------------------------------------------+
void OnBookEvent(const string &symbol)
  {
   static ulong starttime=0;             //  
   static ulong tickcounter=0;           //  
//---    
   if(symbol!=_Symbol)
      return;
//---         
   tickcounter++;
   if(tickcounter<ExtSkipFirstTicks)
      return;

   if(tickcounter==ExtSkipFirstTicks) //  
      starttime=GetMicrosecondCount();

   MarketBookGet(symbol,book);
//---   ?   
   ulong endtime=GetMicrosecondCount()-starttime;
   ulong ticks  =1+tickcounter-ExtSkipFirstTicks;

   if(endtime>ExtCollectTime*1000*1000) //    ?
     {
      PrintFormat("%I64u ticks for %.1f seconds: %.1f ticks/sec ",ticks,endtime/1000.0/1000.0,ticks*1000.0*1000.0/endtime);
      ExpertRemove();
      return;
     }
//---     
   if(endtime>0)
      Comment(StringFormat("%I64u ticks for %.1f seconds: %.1f ticks/sec ",ticks,endtime/1000.0/1000.0,ticks*1000.0*1000.0/endtime));
  }
//+------------------------------------------------------------------+
