//+------------------------------------------------------------------+
//|                                              AsyncTradesTest.mq5 |
//|                        Copyright 2016, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"

//--- input parameters
input int Trades=10;        //    
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---       
   PrintFormat("SyncTradesTest: last ping %.2f ms, build %d",TerminalInfoInteger(TERMINAL_PING_LAST)/1000.0,TerminalInfoInteger(TERMINAL_BUILD));
//---        
   Comment("");
   ObjectsDeleteAll(0);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
   static bool started=false;
//---      
   if(!started)
     {
      started=true;
      Print(__FILE__," starting...");
      //---  
      MqlTradeRequest req={};
      MqlTradeResult  res={};
      int             trades_finished=0;
      ulong           ticks=GetMicrosecondCount();

      req.volume      =1;
      req.symbol      =_Symbol;
      req.sl          =0;
      req.tp          =0;
      req.deviation   =100;
      req.type_filling=ORDER_FILLING_RETURN;
      req.action      =TRADE_ACTION_DEAL;
      req.type        =ORDER_TYPE_BUY;
      req.magic       =2016;
      //---   
      for(int i=0;i<Trades;i++)
        {
         req.price  =SymbolInfoDouble(_Symbol,SYMBOL_ASK);
         req.comment=string(i+1);
         //--- action
         if(!OrderSend(req,res))
           {
            PrintFormat("OrderSend() failed, retcode=%d",res.retcode);
           }
         else
           {
            trades_finished++;
            PrintFormat("#%d Buy %s 1 lot",i+1,_Symbol);
           }
        }
      ticks=GetMicrosecondCount()-ticks;
      //---       
      if(trades_finished>0)
        {
         string comment=StringFormat("Total time: %.3f ms, average: %.3f ms in %d trades",ticks/1000.0,ticks/1000.0/trades_finished,trades_finished);

         Print(comment);
         Comment(comment);
        }
      //---   
      ExpertRemove();
     }
  }
//+------------------------------------------------------------------+
